<template>
    <div class="container mt-5">
        <div class="card">
            <div class="card-header">
                <h4>Add Movie</h4>
            </div>
            <div class="card-body">

                <ul class="alert alert-warning" v-if="Object.keys(this.errorList).length > 0">
                    <li class="mb-0 ms-3" v-for="(error, index) in this.errorList" :key="index">
                        {{ error[0] }}
                    </li>
                </ul>

                <div class="mb-3">
                    <label for="" class="mb-2">Name</label>
                    <input type="text" v-model="model.movie.name" placeholder="Name" class="form-control" />
                </div>
                <div class="mb-3">
                    <label for="" class="mb-2">Description</label>
                    <textarea v-model="model.movie.description" placeholder="Description" class="form-control"
                        rows="3"></textarea>
                </div>
                <div class="mb-3">
                    <label for="" class="mb-2">Rate</label>
                    <input type="text" v-model="model.movie.rate" placeholder="Rate" class="form-control" />
                </div>

                <div class="mb-3">
                    <label for="" class="mb-2">Image</label>
                    <!-- image/* -->
                    <input type="file" @change="onChooseFile" class="form-control" accept=".jpg,.jpeg,.png" />
                </div>
                <div class="action-buttons-container mb-3">
                    <RouterLink :to="{ path: '/movies' }" class="btn btn-secondary my-button mx-2">Back</RouterLink>
                    <button type="button" @click="saveMovie()" class="btn btn-success my-button">Save</button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    name: "movieCreate",
    data() {
        return {
            errorList: '',
            model: {
                movie: {
                    name: '',
                    description: '',
                    rate: '',
                    image: '',
                }
            }
        }
    },
    methods: {
        onChooseFile(event) {
            console.log(event.target.files[0]);
            this.model.movie.image = event.target.files[0];
        },

        saveMovie() {
            var $this = this;
            console.log(this.model.movie);

            const fd = new FormData();
            fd.append("name", this.model.movie.name);
            fd.append("description", this.model.movie.description);
            fd.append("rate", this.model.movie.rate);
            fd.append("image", this.model.movie.image);
            fd.append("_method", "post");

            axios.post('http://localhost:8000/api/movies', fd, {
                headers: {
                    'Authorization': localStorage.getItem('token'),
                }
            }).then(res => {
                console.log(res.data);
                alert(res.data.message);
                // empty the fields after added
                this.model.movie = {
                    name: '',
                    description: '',
                    rate: '',
                    image: '',
                }
                this.errorList = '';
                this.$router.push({ path: '/movies' });
            }).catch(function (error) {
                // debugger;
                if (error.response) {
                    if (error.response.status == 422) {
                        $this.errorList = error.response.data.errors;
                    } else if (error.response.status == 500) {
                        alert(error.response.data.message);
                    }
                } else if (error.request) {
                    console.log(error.request);
                } else {
                    console.log('Error', error.message);
                }
            })
        }
    }
}
</script>

<style>
textarea {
    resize: none;
}

.btn-primary,
.btn-primary:hover,
.btn-primary:focus-visible {
    background: #474646;
    border-color: #474646;
}

.my-button{
    width:6rem;
}

.action-buttons-container {
    float:right;
}
</style>